<!--
-- InputField.vue, emilien <emilien@emilien-pc>, 2020
-->

<template>
	<div class="ui-input">
		<label-field :for="uid" :name="name" class="form__label" />
		<input
			:id="uid"
			v-model="mutatedValue"
			class="form__input"
			:type="type"
			:name="name"
			:placeholder="placeholder"
			@input="updateInput()"
		/>
	</div>
</template>

<script>
import LabelField from './Label';

export default {
	name: 'InputField',
	components: {
		LabelField
	},
	props: {
		name: String,
		value: String,
		type: {
			type: String,
			default: 'text'
		},
		placeholder: {
			type: String,
			default: '',
		}
	},
	data() {
		return {
			uid: `input-${ Math.random().toString(36).substr(2) }`,
			mutatedValue: this.value,
		};
	},
	methods: {
		updateInput() { this.$emit('input', this.mutatedValue); }
	},
};
</script>

<style lang="scss" scoped>

.ui-input {

	>input {
		border: 1px solid #848484;
		width: 100%;
		height: 2.1rem;
		padding: 0 0.5rem;

		&:focus {
			outline: #{clr("teal")} auto 1px;
		}
	}

}

</style>

